function registerBasePtHeightSpin(obj, spin)
    arguments
        obj helix.TomoFilamentUIManager
        spin matlab.ui.control.Spinner
    end

    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(src, evt, obj));
    spin.Limits = [-100, 100];
    
    comg.Node.output("Set Base Point position at height direction", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndViewLattBspt ...
        ).activate();
    
end

function setSpinValue(spin, val)
    spin.Value = val(2);
end

function valueChangedCallback(src, evt, obj)
    arguments
        src matlab.ui.control.Spinner
        evt
        obj helix.TomoFilamentUIManager
    end

    obj.ndViewLattBspt.updateValue([obj.ndViewLattBspt.value(1), src.Value]);
end

