function registerInnRadSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndFilaInnRad, obj.ndFilaOutRad, src, evt));
    
    comg.Node.output("Set Filament Inner Radius", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndFilaInnRad ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndFilaInnRad, ndFilaOutRad, src, evt)
    fprintf('Filament Inner Radius value changed from %d to %d.\n', evt.PreviousValue, evt.Value);

    upder = [];
    if ndFilaOutRad.value < evt.Value
        upder = ndFilaOutRad.updateValue(evt.Value);
    end

    ndFilaInnRad.updateValue(evt.Value, upder);
end

