function registerLoadFilaButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        src, evt, obj));

    comg.Node.output("Enable Load Filament Information Button",...
            @(fila_engine)(enableComponent(butt, fila_engine)), ...
            obj.ndFilaEngn ...
        ).activate();
end

function enableComponent(component, fila_engine)
    flag_enable = isempty(fila_engine) || ~fila_engine.inFilamentTuningMode();
    component.Enable = flag_enable;
end

function buttonPushedCallback(src, evt, obj)
    fprintf("Load Filament Information.\n");

    [filename, pathname] = uigetfile('*.mat', 'Filament Information');
    if filename
        fila_fn = [pathname, filename];
        fd = helix.FilamentDataHandle();
        if exist(fila_fn, 'file')
            fd.loadFromFile(fila_fn);
        end
        eng = helix.FilamentEditingEngine();
        eng.registerFilamentDataHandle(fd);
        obj.registerFilamentEditingEngine(eng);
    end

end
