function registerNlaySpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndTomoLayInd, src, evt));

    comg.Node.output("Set Tomogram Layer Index", ...
            @(tomovol, layind)(setSpinValue(spin, tomovol, layind)), ...
            obj.ndTomoVol, obj.ndTomoLayInd ...
        ).activate();
end

function setSpinValue(spin, tomovol, layind)
    num_tomolay = size(tomovol,3);
    spin.Limits = [1,num_tomolay];
    spin.Value = layind;
end

function valueChangedCallback(ndTomoLayInd, src, evt)
    fprintf('Nlay Spinner value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndTomoLayInd.updateValue(evt.Value);
end

