function registerSaveAxialPtsButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback(obj, src, evt));

    comg.Node.output("Enable Save-Axial-Points-Button",...
            @(fila_engine)(enableComponent(butt, fila_engine)), ...
            obj.ndFilaEngn ...
        ).activate();
end

function enableComponent(component, fila_engine)
    flag_enable = fila_engine.inFilamentTuningMode();
    component.Enable = flag_enable;
end

function buttonPushedCallback(obj, src, evt)
    arguments 
        obj helix.TomoFilamentUIManager
        src
        evt
    end
    fprintf("Save Axial Points button pushed.\n");
    
    smoothed_pts = obj.ndExtrFilaSmthPts.value;
    [filename, pathname] = uiputfile('*.txt', 'Save Axial Points', 'axial_points.txt');
    if filename
        fid = fopen([pathname, filename], 'w');
        for ii = 1:size(smoothed_pts, 2)
            fprintf(fid, '%7.2f %7.2f %7.2f', smoothed_pts(1, ii), smoothed_pts(2, ii), smoothed_pts(3, ii));
            fprintf(fid, '\n');
        end
        fclose(fid);
        fprintf("Axial points saved to %s\n", [pathname, filename]);
    end
end 