function registerSaveSurfPtsButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback(obj, src, evt));

    comg.Node.output("Enable Save-Surface-Points-Button",...
            @(fila_engine, stat_free, stat_foc, rpvvalid)(enableComponent(butt, fila_engine, stat_free, stat_foc, rpvvalid)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc, obj.ndStatRpvValid ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc, rpvvalid)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);
    flag_enable = flag_enable && rpvvalid;
    component.Enable = flag_enable;
end

function buttonPushedCallback(obj, src, evt)
    arguments 
        obj helix.TomoFilamentUIManager
        src
        evt
    end
    fprintf("Save Surface Points button pushed.\n");

    smoothed_pts = obj.ndExtrFilaSmthPts.value;
    rise = obj.ndHpRise.value;
    twist = obj.ndHpTwist.value;
    start_number = obj.ndHpSn.value;
    radius = (obj.ndFilaInnRad.value + obj.ndFilaOutRad.value)/2;
    RMF_r = obj.ndExtrFilaRMFr.value;
    RMF_s = obj.ndExtrFilaRMFs.value;
    RMF_t = obj.ndExtrFilaRMFt.value;
    base_pt = [obj.ndViewLattBspt.value(1)/obj.ndFilaOutRad.value/pi*180; obj.ndViewLattBspt.value(2)];
    
    [positions, qs] = helix.filamentSubunitPoses(rise, twist, start_number, radius, smoothed_pts, RMF_r, RMF_s, RMF_t, base_pt);
    euler_angles = qs.eulerd("ZYZ", "point");

    [filename, pathname] = uiputfile('*.txt', 'Save Surface Points', 'surf_points.txt');
    if filename
        fid = fopen([pathname, filename], 'w');
        pt_num = size(positions, 2);
        for jj = 1:pt_num
            fprintf(fid, "%f %f %f %f %f %f \n", positions(1, jj), positions(2, jj), positions(3, jj), ...
                -euler_angles(jj, 1), -euler_angles(jj, 2), -euler_angles(jj, 3));
        end
        fclose(fid);
        fprintf("Surface points saved to %s\n", [pathname, filename]);
    end
end 