function registerTFDoneButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback(obj.ndFilaEngn, src, evt, obj));
    
    comg.Node.output("Enable TF-Donw-Button",...
            @(fila_engine, stat_free, stat_foc)(enableComponent(butt, fila_engine, stat_free, stat_foc)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);

    component.Enable = flag_enable;
end


function buttonPushedCallback(ndFilaEngn, src, evt, obj)
    arguments
        ndFilaEngn
        src
        evt
        obj helix.TomoFilamentUIManager
    end

    fprintf("TF Done button pushed.\n");

    tag = struct( ...
        "inner_rad", obj.ndFilaInnRad.value, ...
        "outer_rad", obj.ndFilaOutRad.value, ...
        "rpv_a", obj.ndSpecVa.value, ...
        "rpv_b", obj.ndSpecVb.value ...
    );

    ndFilaEngn.value.TF_setFilamentTag(tag);
    ndFilaEngn.value.exitTuningFilamentMode();
    ndFilaEngn.update();
end









