function registerTFOptLenSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndSpecOptLen, src, evt));

    comg.Node.output("Set Opt Range at Length Direction", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndSpecOptLen ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndSpecOptLen, src, evt)
    fprintf('Opt Range at Length Direction value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndSpecOptLen.updateValue(evt.Value);
end

