function score = determinePolarityScore(refmap, stamap)

    assert(all(size(refmap) == size(stamap)));

    coef_pos = -inf;
    coef_neg = -inf;
    angs = 0:2:360-1e-3;
    
    for ang = angs
        q = quaternion([0,0,ang],'eulerd','ZYZ','point');
        refmap_pos = ndtool.volRotate(refmap, q);
        refmap_neg = refmap_pos(end:-1:1,:,end:-1:1);
        coef_pos = max(coef_pos, max(squeeze(tempmatch(refmap_pos, stamap))));
        coef_neg = max(coef_neg, max(squeeze(tempmatch(refmap_neg, stamap))));
    end

    score = coef_pos - coef_neg;
end