function eul_coord = ptCyl2Eul(smth_pts, RMF_r, RMF_s, RMF_t, cyl_coord)
    % cyl_coord: [r;s;t] (1x3 or 3x1)

    if isempty(smth_pts) || isempty(RMF_r) || isempty(RMF_s) || isempty(RMF_t) || isempty(cyl_coord)
        eul_coord = [];
        return;
    end

    sec_ind = max(1,min(size(smth_pts,2), floor(cyl_coord(3)) + 1));
    vr = cyl_coord(1);
    vs = cyl_coord(2);
    vt = cyl_coord(3) - (sec_ind-1);

    eul_coord = smth_pts(:, sec_ind) ...
              + RMF_r(:,sec_ind) * vr ...
              + RMF_s(:,sec_ind) * vs ...
              + RMF_t(:,sec_ind) * vt;
end