function [n, rise, twist] = rpv2hp(va, vb)
    % va = [nn, xx pix^-1]
    % vb = [mm, yy pix^-1]
    % rise xxx pix, twist xxx deg
    
    if ~helix.rpvValid(va, vb)
        n = 0;
        rise = 0;
        twist = 0;
        return;
    end

    [nva, nvb] = regular(va, vb);
    n = -nvb(1);
    rise = 1/nva(2);
    twist = -nvb(2)/(nvb(1)*nva(2)) * 360;

end

function [nva, nvb] = regular(va, vb)
    [nc, ga, gb] = gcd(va(1),vb(1));
    nva = vb(1)/nc*va - va(1)/nc*vb;
    if nva(2) < 0
        nva = -nva;
    end
    nvb = -ga*va - gb*vb;
end