function [ua, ub] = rpv2pv(va, vb)
    % unit of va/vb is [1/2pi, pix^-1]
    % unit of ua/ub is [deg, pix]
    
    va = va(:);
    vb = vb(:);

    R = [0,1;-1,0];
    ua = (R*vb)/(va.'*R*vb);
    ub = (R*va)/(vb.'*R*va);
    
    ua(1) = ua(1)*360;
    ub(1) = ub(1)*360;
    
end