function symm_vol = volHelicalExpand(vol, rise, twist, order)
%   msn: minminal start number, or the fold number of rotation symmetize
%   rise: in pixel
%   twist: in degree
%   order: order of implementing helical symmetry

    volsz = size(vol);
    [vx, vy, vz] = cencoord(volsz);
    vxb = cencoord(volsz(1));
    vyb = cencoord(volsz(2));
    vzb = cencoord(volsz(3));

    z_ord = round(vz / rise);
    
    ref_z = vz - z_ord*rise;
    ref_theta = -z_ord*twist;
    ref_x = vx .* cosd(ref_theta) - vy .* sind(ref_theta);
    ref_y = vy .* cosd(ref_theta) + vx .* sind(ref_theta);

    z_msk = abs(vzb) < rise*(order + 0.5);
    symm_vol = permute(z_msk, [3,2,1]).*reshape(interp3(vyb, vxb, vzb, vol, ref_y(:), ref_x(:), ref_z(:), 'linear', 0), volsz);

end