function rotated_vol = volRotate(vol, q, opt)
    arguments
        vol 
        q quaternion
        opt.interp_type = "linear"
        opt.target_size = []
    end

    volsz = size(vol);
    if isempty(opt.target_size)
        target_size = volsz;
    else
        target_size = opt.target_size;
    end

    [vx, vy, vz] = cencoord(target_size);
    vcd = [vx(:),vy(:),vz(:)];
    
    vxb = cencoord(volsz(1));
    vyb = cencoord(volsz(2));
    vzb = cencoord(volsz(3));
    
    vcd_rt = q.rotateframe(vcd);
    rotated_vol = reshape(interp3(vyb, vxb, vzb, vol, vcd_rt(:,2), vcd_rt(:,1), vcd_rt(:,3), opt.interp_type, 0), volsz);


end