function cen_pos = cenpos(size, dim)
%CENPOS - return the position of origin point of an image.
%   CENPOS = CENPOS(SIZE) return the origin point of an image of given
%   SIZE.
%
%   CENPOS = CENPOS(SIZE, DIM) return the index of origin point at DIM-th
%   dimension.
%
% See also: CENCOORD.

% Author: Mingtao Huang
% E-mail: hermitw57@outlook.com
% Last revision: 07-Feb-2020

%------------- BEGIN --------------

cen_pos = round((size+1)./2);

if nargin > 1
    cen_pos = cen_pos(dim);
end

%-------------- END ---------------
