function ndt = cenrsz(src, nsz)
% resize, resize the source object to newsize.
% Input:
%   src: source
%   nsz: new size
% Output:
%   ndt: new data

osz = size(src);
osz = [osz, ones(1, length(nsz) - length(osz))];
nsz = arrayexpand(nsz, [1, length(osz)]);

src_center = cenpos(osz);
new_center = cenpos(nsz);

src_start_pos = max(1, 1 - new_center + src_center);
src_end_pos = min(osz, nsz - new_center + src_center);
new_start_pos = max(1, 1 - src_center + new_center);
new_end_pos = min(nsz, osz - src_center + new_center);

ndt = zeros(nsz);
cmd = 'ndt(new_start_pos(1):new_end_pos(1)';
for n = 2:length(nsz)
    ns = num2str(n);
    cmd = [cmd, ',new_start_pos(', ns, '):new_end_pos(', ns, ')'];
end
cmd = [cmd, ')=src(src_start_pos(1):src_end_pos(1)'];
for n = 2:length(nsz)
    ns = num2str(n);
    cmd = [cmd, ',src_start_pos(', ns, '):src_end_pos(', ns, ')'];
end
cmd = [cmd, ');'];
eval(cmd);

end

